unit uInputQueryInt;

   /////////////////////////////////////////////////////////////////////////////
   //    InputQuery avec empchement de saisir des caractres non numriques  //
   //       tout en autorisant Ctrl + A, Ctrl+C et Ctrl+V                     //
   /////////////////////////////////////////////////////////////////////////////

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls;

type
  TfrmInputQueryInt = class(TForm)
    btnOK: TSpeedButton;
    btnAnnuler: TSpeedButton;
    Edit1: TEdit;
    Label1: TLabel;
    procedure btnOKClick(Sender: TObject);
    procedure btnAnnulerClick(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
  private
    { Dclarations prives }
    Res : boolean;
  public
    { Dclarations publiques }
  end;

var
  frmInputQueryInt: TfrmInputQueryInt;

function InputQueryInt(const ACaption, APrompt: string; var Value: string): Boolean;
procedure EditEntierNONSigne(Sender: TObject; var Key: Char);

implementation

{$R *.dfm}

function InputQueryInt(const ACaption, APrompt: string; var Value: string): Boolean;
begin
  with frmInputQueryInt do begin
    Res :=false;
    Caption:=ACaption; Label1.Caption:=APrompt; Edit1.Text:=Value;
    Edit1.SelectAll;
    ShowModal;
    Result:=Res; Value:=Edit1.Text;
   end;
end;

procedure TfrmInputQueryInt.btnOKClick(Sender: TObject);
begin
    Res :=true; Close;
end;

procedure TfrmInputQueryInt.btnAnnulerClick(Sender: TObject);
begin
   Res:=false; Close;
end;

procedure EditEntierNONSigne(Sender: TObject; var Key: Char);
//        Empche de saisir des caractres non numriques tout en autorisant Ctrl + A, Ctrl+C et Ctrl+V
var       ed : TEdit;
begin     if (Key = '.') then Key := #0;
          if key=Chr(VK_RETURN) then frmInputQueryInt.btnOKClick(Sender); // Touche Enter
          if key=#1 then begin // #1 = Ctrl + A
             ed:=(Sender as tEdit);
             ed.SelectAll; EXIT;
          end;
          if not (Key in [#3,#22,'0'..'9', Chr(VK_BACK), Chr(VK_DELETE)]) //#3 = Ctrl + C, #22 = Ctrl + V
          then Key := #0;
end;

procedure TfrmInputQueryInt.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
    EditEntierNONSigne(Sender,Key);
end;

end.

